org.apache.hc.core5.http.impl

## Class DefaultConnectionReuseStrategy

- java.lang.Object
- - org.apache.hc.core5.http.impl.DefaultConnectionReuseStrategy

- All Implemented Interfaces:
    ConnectionReuseStrategy

      @Contract(threading=IMMUTABLE)
      public class DefaultConnectionReuseStrategy
      extends Object
      implements ConnectionReuseStrategy

  Default implementation of a strategy deciding about connection re-use. The strategy determines whether a connection is persistent or not based on the message’s protocol version and `Connection` header field if present. Connections will not be re-used and will close if any of these conditions is met
  - the `close` connection option is present in the request message
  - the response message content body is incorrectly or ambiguously delineated
  - the `close` connection option is present in the response message
  - If the received protocol is `HTTP/1.0` (or earlier) and `keep-alive` connection option is not present
  In the absence of a `Connection` header field, the non-standard but commonly used `Proxy-Connection` header field will be used instead. If no connection options are explicitly given the default policy for the HTTP version is applied. `HTTP/1.1` (or later) connections are re-used by default. `HTTP/1.0` (or earlier) connections are not re-used by default.
  Since:
    4.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static DefaultConnectionReuseStrategy` | `INSTANCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultConnectionReuseStrategy()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `keepAlive(HttpRequest request, HttpResponse response, HttpContext context)` Decides whether a connection can be kept open after a request.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INSTANCE

          public static final DefaultConnectionReuseStrategy INSTANCE

  - ### Constructor Detail

    - #### DefaultConnectionReuseStrategy

          public DefaultConnectionReuseStrategy()

  - ### Method Detail

    - #### keepAlive

          public boolean keepAlive(HttpRequest request,
                                   HttpResponse response,
                                   HttpContext context)

      Description copied from interface: `ConnectionReuseStrategy`
      Decides whether a connection can be kept open after a request. If this method returns `false`, the caller MUST close the connection to correctly comply with the HTTP protocol. If it returns `true`, the caller SHOULD attempt to keep the connection open for reuse with another request.

      One can use the HTTP context to retrieve additional objects that may be relevant for the keep-alive strategy: the actual HTTP connection, the original HTTP request, target host if known, number of times the connection has been reused already and so on.

      If the connection is already closed, `false` is returned. The stale connection check MUST NOT be triggered by a connection reuse strategy.

      Specified by:
        `keepAlive` in interface `ConnectionReuseStrategy`
      Parameters:
        `request` - The last request transmitted over that connection.
        `response` - The last response transmitted over that connection.
        `context` - the context in which the connection is being used.
      Returns:
        `true` if the connection is allowed to be reused, or `false` if it MUST NOT be reused

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.